.\" $OpenBSD: dhclient.8,v 1.20 2013/02/23 22:00:37 krw Exp $
.\"
.\" Copyright (c) 1997 The Internet Software Consortium.
.\" All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\"
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. Neither the name of The Internet Software Consortium nor the names
.\"    of its contributors may be used to endorse or promote products derived
.\"    from this software without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE INTERNET SOFTWARE CONSORTIUM AND
.\" CONTRIBUTORS ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES,
.\" INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
.\" MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
.\" DISCLAIMED.  IN NO EVENT SHALL THE INTERNET SOFTWARE CONSORTIUM OR
.\" CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
.\" SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
.\" LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
.\" USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
.\" ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
.\" OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
.\" OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.\" This software has been written for the Internet Software Consortium
.\" by Ted Lemon <mellon@fugue.com> in cooperation with Vixie
.\" Enterprises.  To learn more about the Internet Software Consortium,
.\" see ``http://www.isc.org/isc''.  To learn more about Vixie
.\" Enterprises, see ``http://www.vix.com''.
.Dd $Mdocdate: February 23 2013 $
.Dt DHCLIENT 8
.Os
.Sh NAME
.Nm dhclient
.Nd Dynamic Host Configuration Protocol (DHCP) client
.Sh SYNOPSIS
.Nm
.Op Fl dqu
.Op Fl c Ar file
.Op Fl i Ar options
.Op Fl L Ar file
.Op Fl l Ar file
.Ar interface
.Sh DESCRIPTION
The
.Nm
utility provides a means for configuring network interfaces using DHCP, BOOTP,
or if these protocols fail, by statically assigning an address.
.Pp
The name of the network interface that
.Nm
should attempt to
configure must be specified on the command line.
.Pp
The options are as follows:
.Bl -tag -width Ds
.It Fl c Ar file
Specify an alternate location to
.Pa /etc/dhclient.conf
for the configuration file.
.It Fl d
Forces
.Nm
to always run as a foreground process.
By default,
.Nm
runs in the foreground until it has configured the interface, and then
will revert to running in the background.
.It Fl i Ar options
.Nm
will ignore any values provided by leases for the options specified.
This list will override any ignore statements in
.Xr dhclient.conf 5 .
.Ar options
must be a comma separated list of valid option names.
Invalid option names will cause the entire list to be discarded.
.It Fl L Ar file
Specify a
.Ar file
to write the option data to.
This causes
.Nm
to write two pseudo-leases,
.Dq offered
and
.Dq effective ,
to the specified file.
The offered block will contain the lease offered by the DHCP server;
the effective block will contain the modified lease used to configure the
interface.
.It Fl l Ar file
Specify an alternate location to
.Pa /var/db/dhclient.leases. Ns Aq Ar IFNAME
for the leases file.
.It Fl q
Forces
.Nm
to be less verbose on startup.
.It Fl u
Forces
.Nm
to reject leases with unknown options in them.
The default behaviour is to accept such lease offers.
.El
.Pp
The DHCP protocol allows a host to contact a central server which
maintains a list of IP addresses which may be assigned on one or more
subnets.
A DHCP client may request an address from this pool, and
then use it on a temporary basis for communication on the network.
The DHCP protocol also provides a mechanism whereby a client can learn
important details about the network to which it is attached, such as
the location of a default router, the location of a name server, and
so on.
.Pp
On startup,
.Nm
reads
.Pa /etc/dhclient.conf
for configuration instructions.
It then attempts to configure the network interface
.Ar interface
with DHCP.
The special value
.Dq egress
may be used instead of a network interface name.
In this case
.Nm
will look for the network interface currently in the interface group
.Dq egress
and configure it with DHCP.
If there is more than one network interface in the egress group
.Nm
will exit with an error.
.Pp
When configuring the interface,
.Nm
attempts to remove any existing addresses, gateway routes that use
the interface, and non-permanent
.Xr arp 8
entries.
Conversely, if the interface is later manipulated to add or delete
addresses then
.Nm
will automatically exit.
It thus automatically exits whenever a new
.Nm
is run on the same interface.
.Pp
Once the interface is configured,
.Nm
constructs a
.Xr resolv.conf 5
file.
It does this only when one or both of the options
.Cm domain-name
and
.Cm domain-name-servers
is present.
(note that these options may be offered by the DHCP server but suppressed by
.Xr dhclient.conf 5 ) .
If a resolv.conf is constructed,
.Nm
appends any contents of the
.Xr resolv.conf.tail 5
file, which are read once at start up.
The constructed resolv.conf is copied into
.Pa /etc/resolv.conf
whenever the default route goes out the interface
.Nm
is running on.
.Nm
monitors the system for changes to the default route and re-checks
whether it should write its resolv.conf when possible changes are
detected.
.Pp
In order to keep track of leases across system reboots and server
restarts,
.Nm
keeps a list of leases it has been assigned in the
.Pa /var/db/dhclient.leases. Ns Aq Ar IFNAME
file.
.Ar IFNAME
represents the network interface of the DHCP client
.Pq e.g. em0 ,
one for each interface.
On startup, after reading the
.Xr dhclient.conf 5
file,
.Nm
reads the leases file to refresh its memory about what leases it has been
assigned.
.Pp
Old leases are kept around in case the DHCP server is unavailable when
.Nm
is first invoked (generally during the initial system boot
process).
In that event, old leases from the
.Pa dhclient.leases. Ns Aq Ar IFNAME
file which have not yet expired are tested, and if they are determined to
be valid, they are used until either they expire or the DHCP server
becomes available.
.Pp
A mobile host which may sometimes need to access a network on which no
DHCP server exists may be preloaded with a lease for a fixed
address on that network.
When all attempts to contact a DHCP server have failed,
.Nm
will try to validate the static lease, and if it
succeeds, it will use that lease until it is restarted.
.Pp
A mobile host may also travel to some networks on which DHCP is not
available but BOOTP is.
In that case, it may be advantageous to
arrange with the network administrator for an entry on the BOOTP
database, so that the host can boot quickly on that network rather
than cycling through the list of old leases.
.Pp
.Nm
requires at least one
.Pa /dev/bpf*
file for each broadcast network interface.
See
.Xr bpf 4
for more information.
.Sh SIGNALS
While running,
.Nm
reacts to a few different signals:
.Bl -tag -width "USR1, USR2XXX"
.It Dv HUP
On receiving
.Dv HUP
.Nm
will restart itself, reading
.Xr dhclient.conf 5
and obtaining a new lease.
.It Dv INT
On receiving
.Dv INT
.Nm
will exit after attempting to remove any routes, interface addresses
or temporary files it created.
.It Dv QUIT
On receiving
.Dv QUIT
.Nm
will dump core and exit without attempting to remove any routes, interface
addresses or temporary files it created.
.It Dv TERM
On receiving
.Dv TERM
.Nm
will exit without attempting to remove any routes, interface addresses
or temporary files it created.
.It Dv USR1, USR2
On receiving either
.Dv USR1
or
.Dv USR2 ,
.Nm
will exit after attempting to remove any routes, interface addresses
or temporary files it created.
.El
.Sh FILES
.Bl -tag -width "/var/db/dhclient.leases.<IFNAME>XXX" -compact
.It Pa /etc/dhclient.conf
DHCP client configuration file
.It Pa /var/db/dhclient.leases. Ns Aq Ar IFNAME
database of acquired leases
.El
.Sh SEE ALSO
.Xr bpf 4 ,
.Xr dhclient.conf 5 ,
.Xr dhclient.leases 5 ,
.Xr dhcp 8 ,
.Xr dhcpd 8 ,
.Xr dhcrelay 8
.Sh AUTHORS
.An -nosplit
.Nm
was written by
.An Ted Lemon Aq mellon@fugue.com
and
.An Elliot Poger Aq elliot@poger.com .
.Pp
The current implementation was reworked by
.An Henning Brauer Aq henning@openbsd.org .
